//+------------------------------------------------------------------
//|                                       Fibonacci Lucas time series
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern color  FibonacciColor   = PaleVioletRed;
extern color  LucasColor       = DeepSkyBlue;
extern bool   ShowFibonacci    = true;
extern bool   ShowLucas        = true;
extern bool   ShowOnChartBars  = true;
extern int    BarsWidth        = 3;
extern string UniqueIdentifier = "FibonacciLucas1";

//
//
//
//
//

double fib[];
double luc[];
double count[];


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,fib); SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,EMPTY,FibonacciColor);
   SetIndexBuffer(1,luc); SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,EMPTY,LucasColor);
   SetIndexBuffer(2,count);
   return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = UniqueIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0); 
}


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double fibCnt[] = {5,8,13,21,34,55,89,144,233,377,610,987,1597,2584,4181,6785};
double lucCnt[] = {3,4, 7,11,18,29,47, 76,123,199,322,521, 843,1364,2207,3571};

//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for (i=limit; i>= 0; i--)
   {
      fib[i] = EMPTY_VALUE;
      luc[i] = EMPTY_VALUE;
      
         if (TimeDay(Time[i])!=TimeDay(Time[i+1]))
               count[i] = 1;
         else  count[i] = 1+count[i+1];
         if (ShowFibonacci && fibCnt[ArrayBsearch(fibCnt,count[i])]==count[i]) { fib[i] = 1; manageBar("fib",i,FibonacciColor,BarsWidth); }
         if (ShowLucas     && lucCnt[ArrayBsearch(lucCnt,count[i])]==count[i]) { luc[i] = 1; manageBar("luc",i,LucasColor    ,BarsWidth); }
   }

   //
   //
   //
   //
   //
   
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

void manageBar(string add, int i, color theColor, int size)
{
   if (ShowOnChartBars)
   {
      deleteBar(add+Time[i]);
        drawBar(add,i,theColor,size);
   }
}               

//
//
//
//
//

void drawBar(string add, int i,color theColor, int theSize)
{
   string name = UniqueIdentifier+":"+add+Time[i];
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_TREND,0,Time[i],0,Time[i],0);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,theSize);
         ObjectSet(name,OBJPROP_PRICE1,High[i]);
         ObjectSet(name,OBJPROP_PRICE2,Low[i]);
         ObjectSet(name,OBJPROP_RAY,false);
}

//
//
//
//
//

void deleteBar(string add)
{
   string lookFor = UniqueIdentifier+":"+add; ObjectDelete(lookFor);
}